%global gemdir %(ruby -rubygems -e 'puts Gem::dir' 2>/dev/null)
%global gemname database_cleaner
%global geminstdir %{gemdir}/gems/%{gemname}-%{version}

Summary: Strategies for cleaning databases
Name: rubygem-%{gemname}
Version: 0.6.6
Release: 2%{?dist}
Group: Development/Languages
License: MIT
URL: http://github.com/bmabey/database_cleaner
Source0: http://rubygems.org/gems/%{gemname}-%{version}.gem

# Prepare for future, use RSpec 2
Patch0: RSpec-2.x-compatibility.patch
# ERB should be required explicitely
# https://github.com/bmabey/database_cleaner/issues/54
Patch1: Explicitly-require-ERB.patch

Requires: rubygems
Requires: ruby(abi) = 1.8
BuildRequires: rubygems
# Use rspec-core until rspec are not migrated to RSpec 2.x
BuildRequires: rubygem(rspec-core)
BuildRequires: rubygem(activerecord)
BuildArch: noarch
Provides: rubygem(%{gemname}) = %{version}

%description
The original use case was to ensure a clean state during tests. Each strategy
is a small amount of code but is code that is usually needed in any ruby app
that is testing with a database

%package	doc
Summary:        Documentation for %{gemname}
Group:          Documentation
Requires:       %{name} = %{version}-%{release}

%description    doc
This package contains documentation for %{gemname}

%prep
%setup -q -c -T
mkdir -p .%{gemdir}
gem install --local --install-dir .%{gemdir} \
            --force --rdoc %{SOURCE0}

pushd .%{geminstdir}
%patch0 -p1
%patch1 -p1
popd

%build

%install
mkdir -p %{buildroot}%{gemdir}
cp -a .%{gemdir}/* \
        %{buildroot}%{gemdir}/
chmod -x %{buildroot}%{geminstdir}/lib/database_cleaner/active_record/truncation.rb
chmod -x %{buildroot}%{geminstdir}/examples/Gemfile

%check
pushd .%{geminstdir}

# Bundler just complicates everything in our case, remove it.
sed -i -e 's|require "bundler"||' spec/spec_helper.rb
sed -i -e 's|Bundler.setup||' spec/spec_helper.rb
rm spec/spec.opts

# ActiveRecord is the only available ORM in F15.
rspec spec/database_cleaner/generic/ spec/database_cleaner/active_record
popd

%files
%defattr(-, root, root, -)
%dir %{geminstdir}
%{geminstdir}/lib
%{geminstdir}/LICENSE
%{geminstdir}/README.textile
%{gemdir}/cache/%{gemname}-%{version}.gem
%{gemdir}/specifications/%{gemname}-%{version}.gemspec

%files doc
%defattr(-, root, root, -)
%{gemdir}/doc/%{gemname}-%{version}
%{geminstdir}/Gemfile.lock
%{geminstdir}/TODO
%{geminstdir}/examples
%{geminstdir}/spec
%{geminstdir}/features
%{geminstdir}/History.txt
%{geminstdir}/*.yml
%{geminstdir}/Rakefile

%changelog
* Fri Jul 01 2011 Vít Ondruch <vondruch@redhat.com> - 0.6.6-2
- Fixed -doc subpackage dependency.

* Mon Mar 21 2011 Vít Ondruch <vondruch@redhat.com> - 0.6.6-1
- Updated upstream version.

* Mon Mar 21 2011 Vít Ondruch <vondruch@redhat.com> - 0.5.2-2
- Added tests.

* Wed Oct 06 2010 Jozef Zigmund <jzigmund@redhat.com> - 0.5.2-1
- Initial package
